%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function DB_MPC_Modify_RBE2(MPC_ID, Ind_Node, Dep_Node_list, Dep_DOFs)

global ErrCode;

global DB_MPC;
global AST_NODES;

global AT_MPC;
global AT_NODES;

Dep_Node_list = unique(Dep_Node_list);

% Проверка существования в базе MPC
if (~DB_MPC_Exist(MPC_ID))
    fprintf (1, '\nОшибка функции DB_MPC_Modify_RBE2: MPC с номером %i отсутствует в базе !\n', MPC_ID);
    ErrCode = -1;
    return;
end

% Проверка типа MPC
if (~strcmp(DB_MPC{AT_MPC(MPC_ID)}.type, 'RBE2'))
    fprintf (1, '\nОшибка функции DB_MPC_Modify_RBE2: MPC с номером %i имеет тип [%s] !\n', MPC_ID, DB_MPC{AT_MPC(MPC_ID)}.type);
    ErrCode = -1;
    return;
end

% Проверка существования в базе независимого узла
if (~DB_Node_Exist(Ind_Node))
    fprintf (1, '\nОшибка функции DB_MPC_Modify_RBE2: узел с номером %i отсутствует в базе !\n', Ind_Node);
    ErrCode = -1;
    return;
end

% Проверка существования в базе зависимых узлов
for i=1:size(Dep_Node_list,1)
    if (~DB_Node_Exist(Dep_Node_list(i)))
        fprintf (1, '\nОшибка функции DB_MPC_Modify_RBE2: узел с номером %i отсутствует в базе !\n', Dep_Node_list(i));
        ErrCode = -1;
        return;
    end
end

% Проверка на отсутствие независимого узла в списке зависимых
if (~isempty(intersect(Ind_Node, Dep_Node_list)))
    fprintf (1, '\nОшибка функции DB_MPC_Modify_RBE2: независимый узел [%i] содержится в списке зависимых узлов !\n', Ind_Node);
    ErrCode = -1;
    return;
end

% Списки старых и новых узлов
Old_Nodes_list = Union_Column(DB_MPC{AT_MPC(MPC_ID)}.ind_grid, DB_MPC{AT_MPC(MPC_ID)}.dep_grid);
New_Nodes_list = Union_Column(Ind_Node, Dep_Node_list);

% Списки добавления и удаления
Add_Nodes_list = setdiff(New_Nodes_list, Old_Nodes_list);
Remove_Nodes_list = setdiff(Old_Nodes_list, New_Nodes_list);

% Внесение изменений в таблицу ассоциативности узлов
if (~isempty(Remove_Nodes_list))
    for i=1:size(Remove_Nodes_list,1)
        AST_NODES{AT_NODES(Remove_Nodes_list(i))}.MPC_list = setdiff(AST_NODES{AT_NODES(Remove_Nodes_list(i))}.MPC_list, MPC_ID);
        if (isempty(AST_NODES{AT_NODES(Remove_Nodes_list(i))}.MPC_list))
            AST_NODES{AT_NODES(Remove_Nodes_list(i))}.MPC_list = [];
        end
    end
end

if (~isempty(Add_Nodes_list))
    for i=1:size(Add_Nodes_list,1)
        AST_NODES{AT_NODES(Add_Nodes_list(i))}.MPC_list = Union_Column(AST_NODES{AT_NODES(Add_Nodes_list(i))}.MPC_list, MPC_ID);
    end
end

% Изменение записи в базе
DB_MPC{AT_MPC(MPC_ID)}.ind_grid = Ind_Node;
DB_MPC{AT_MPC(MPC_ID)}.dep_grid = Dep_Node_list;
DB_MPC{AT_MPC(MPC_ID)}.dep_DOF = Dep_DOFs;
